# 陆战棋

    陆战棋，又称军棋，是中国近代的一种根据军队中的军衔设计的双人、四人棋类。每一方有25枚棋子，先夺得对方军旗者为胜。

棋盘上每方有三十个停靠点，当中两个为大本营，另有行营五个。棋盘上的线分为两种：铁路线、公路线。两方势力通过三条铁路连接，每两条铁路之间有一个“山界”。

![](public/board.png)

| 棋子 | 数量 | 说明                         |
| ---- | ---- | ---------------------------- |
| 军旗 | 1    | 必须布置在大本营，不得移动   |
| 炸弹 | 2    | 不得布置在第一排             |
| 地雷 | 3    | 必须布置在最后两排，不得移动 |
| 司令 | 1    | 可吃以下任何棋子             |
| 军长 | 1    | 可吃以下任何棋子             |
| 师长 | 2    | 可吃以下任何棋子             |
| 旅长 | 2    | 可吃以下任何棋子             |
| 团长 | 2    | 可吃以下任何棋子             |
| 营长 | 2    | 可吃以下任何棋子             |
| 连长 | 3    | 可吃以下任何棋子             |
| 排长 | 3    | 可吃以下任何棋子             |
| 工兵 | 3    | 可以吃地雷                   |

## 规则

1. 双方将己方棋子按规则秘密地布置在己方棋盘的兵站或大本营中后战斗开始;
2. 黑方先行，然后依次行棋;
3. 军旗、大本营内的棋子、地雷等不能移动;
4. 行棋不得跨越已有棋子的位置;
5. 在公路线上，棋子每回合只能沿公路线，向有连线的方向走一格;
6. 在铁路线上，沿铁路无子阻挡时，棋子可可以直线行动不限格数（部分地区规定工兵外所有可动棋子在铁路上最多只可走三格，但可拐弯）。 若该棋子为工兵，可沿中间路程未被阻挡的铁路线行进至可能达到的任一位置；
7. 走入有敌方棋子的位置时即为攻击;
8. 不得攻击己方棋子或行营内的棋子;
9. 攻击时双方棋子相同，则同归于尽;
10. 炸弹不能攻击军旗，攻击其它棋子则同归于尽;
11. 攻击地雷则同归于尽，工兵除外;
12. 部分地区规定司令不可攻击军旗;
13. 攻击结果由裁判作出，双方不得知晓对方棋子;
14. 己方司令被消灭后强制向敌方明示己方军旗所在位置（部分地区规则规定司令+军长被消灭后须翻开非军旗的大本营中的棋子）;
15. 攻击敌方军旗或敌方失去所有机动力时，则为获胜！

## 实现步骤
- 显示棋盘底图
- 实现虚拟的兵站、行营、大本营，并与底图对齐
- 棋子可以按规则放入兵站、行营、大本营
- 实现轮流行棋
- 实现行棋规则
- 实现吃子
- 实现输赢
